<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\SolicitacaoService;
use FM\Traits\TResponse;

class SolicitacaoController
{

    use TResponse;
    protected $SolicitacaoService;

    public function __construct(SolicitacaoService $SolicitacaoService)
    {
        $this->SolicitacaoService = $SolicitacaoService;
    }


    public function showRequest(Request $request)
    {
        try {
            $data = $this->SolicitacaoService->showRequest($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getSituationRequest()
    {
        try {
            $data = $this->SolicitacaoService->getSituationRequest();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getNameRequest()
    {
        try {
            $data = $this->SolicitacaoService->getNameRequest();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getLocalRequest(Request $request, Response $response)
    {
        try {
            $var = $this->SolicitacaoService->getLocalRequest($request->getParameters());
            $dtsVal = new DataSet('local', $var);
            $response->addDataSet($dtsVal);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    // Refatoração de tela

    public function getSolicitacoes(Request $request)
    {
        try {
            $data = $this->SolicitacaoService->getSolicitacoes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function criarSolicitacao(Request $request)
    {
        try {
            $data = $this->SolicitacaoService->criarSolicitacao($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function avaliarSolicitacao(Request $request)
    {
        try {
            $data = $this->SolicitacaoService->avaliarSolicitacao($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFotosSolicitacao(Request $request)
    {
        try {
            $data = $this->SolicitacaoService->getFotosSolicitacao($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
