<?php

namespace FM\Service;

use FM\Factory\Fm00011000NaoConformidadesFactory;
use FM\Service\FindService;
use Teknisa\Libs\Util\Environment;

class Fm00011000NaoConformidadesService
{

    protected $naoConformidadesFactory;
    protected $environment;
    protected $findService;

    public function __construct(Fm00011000NaoConformidadesFactory $naoConformidadesFactory, FindService $findService, Environment $environment)
    {
        $this->naoConformidadesFactory         = $naoConformidadesFactory;
        $this->environment                     = $environment;
        $this->findService                     = $findService;
    }

    public function getNaoConformidadesGerais($params)
    {

        $filter = "";
        if (isset($params['NRLOCALCLIENTE'])) {
            $NR = $this->findService->formatarArray($params['NRLOCALCLIENTE']);
            $filter .= "AND LOC.NRLOCALCLIENTE IN  ($NR) ";
        }
        if (isset($params['NRTIPOLOCALCLI'])) {
            $NR = $this->findService->formatarArray($params['NRTIPOLOCALCLI']);
            $filter .= "AND LOC.NRTIPOLOCALCLI IN  ($NR) ";
        }
        if (isset($params['CDOPERADOR'])) {
            $NR = $this->findService->formatarArray($params['CDOPERADOR']);
            $filter .= "AND OPER.CDOPERADOR IN  ($NR) ";
        }
        if (isset($params['CDOPERADORPAI'])) {
            $NR = $this->findService->formatarArray($params['CDOPERADORPAI']);
            $filter .= "AND HC.CDOPERADORPAI IN  ($NR) ";
        }
        if (isset($params['filtroDataRange'])) {
            $dataInicial = $params['filtroDataRange'][0];
            $dataFinal =  property_exists("1", $params['filtroDataRange'][1]) ? $params['filtroDataRange'][1] : null;

            if ($dataFinal != null) {
                $filter .= "AND GECHK.DTHORAAGEND BETWEEN '" . $dataInicial . "' AND '" . $dataFinal . "'";
            } else {
                $filter .= "AND GECHK.DTHORAAGEND BETWEEN '" . $dataInicial . "' AND '" . $dataInicial . "'";
            }
        }

        return $this->naoConformidadesFactory->getNaoConformidadesGerais($filter);
    }

    public function getPrincipaisNaoConformidades($params)
    {
        $filter = "";
        
        if (isset($params['filtroDataRange'])) {
            $dataInicial = $params['filtroDataRange'][0];
            $dataFinal = property_exists("1", $params['filtroDataRange'][1]) ? $params['filtroDataRange'][1] : null;

            if ($dataFinal != null) {
                $filter .= "AND GECHK.DTHORAAGEND BETWEEN '" . $dataInicial . "' AND '" . $dataFinal . "'";
            } else {
                $filter .= "AND GECHK.DTHORAAGEND BETWEEN '" . $dataInicial . "' AND '" . $dataInicial . "'";
            }
        }
        return $this->naoConformidadesFactory->getPrincipaisNaoConformidades($filter);
    }
}
