// eslint-disable-next-line
/* eslint-disable no-console */
/* eslint-disable */
import {
  AlertService, Form, MenuLink, Button
} from '@zeedhi/common';
import {
  Http, IDictionary, Metadata, Router,
} from '@zeedhi/core';

export class LoginControllerAcesso {
  // Variáveis que controllam a visibilidade dos elementos do menu
  public isVisibleTasks = !(localStorage.getItem('idpermissstarefas') === 'N');

  public isVisibleInspections = !(localStorage.getItem('idpermisssvistoria') === 'N');

  public isVisibleReports = !(localStorage.getItem('idpermisssrelatorios') === 'N');

  public isVisibleCalendar = !(localStorage.getItem('idpermissscalend') === 'N');

  public isVisibleDashboard = (localStorage.getItem('idpermisssDashboards') === 'O');

  public isVisibleDashboardSupervisor = (localStorage.getItem('idpermisssDashboards') != 'O');

  public isVisibleQRCode = !(localStorage.getItem('idpermissstarefas') === 'N' && localStorage.getItem('idpermissstarefas') === 'N');

  public logar() {
    if (Metadata.getInstance<Form>('login-form').validate()) {
      Http.post('/validaLogin', Metadata.getInstance<Form>('login-form').value).then((response: IDictionary) => {
        const database = response.data.dataset.func;
        if ((Object.keys(response.data.dataset.func)).length) {
          this.setUser(database.NRFUNCIONARIO, database.TOKEN);
        } else {
          this.loginFail();
        }
      })
        .catch((err) => {
          alert(err);
        });
    }
  }

  public setUser(nr: number, token: string) {
    window.localStorage.setItem('UserLogado', String(nr));
    window.localStorage.setItem('Token', token);

    Router.replace('/');
  }

  public loginFail() {
    AlertService.show({
      name: 'basic-alert',
      text: 'Login ou senha invalida!',
      top: true,
      left: false,
      timeout: 3000,
      color: 'error',
    });
  }

  public delet() {
    window.localStorage.clear();
    Router.replace('/Login');
  }

  // Gerencia as informações do LocalStorage, sempre reatualizando as informações
  public manageLocalStorageInfo() {
    const nrfuncionario = localStorage.getItem('UserLogado');

    Http.get(`/get/${nrfuncionario}/userPermiss`).then((response: IDictionary) => {
      const database = response.data.dataset.info[0];
      if (localStorage.getItem('Token') === database.TOKEN) {
        window.localStorage.setItem('idpermisssvistoria', database.IDPERMISSSVISTORIA);
        window.localStorage.setItem('idpermissstarefas', database.IDPERMISSSTAREFAS);
        window.localStorage.setItem('idpermisssrelatorios', database.IDPERMISSSRELATORIOS);
        window.localStorage.setItem('idpermissscalend', database.IDPERMISSSCALEND);
        window.localStorage.setItem('idpermisssDashboards', database.IDTIPODASHBOARD);
      } else {
        window.localStorage.clear();
        Router.replace('/Login');
      }
    });

  }
}
